



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>C/C++语言中const的用法</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">C/C++语言中const的用法</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-28 01:06:15 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/841516/201603/841516-20160308092315179-589574121.png" /></h2>
<h2>1. const 在C和C++中的区别</h2>
<div>&nbsp; &nbsp;&nbsp;C++中的const正常情况下是看成编译期的常量,编译器并不为const分配空间,只是在编译的时候将期值保存在名字表中,并在适当的时候折合在代码中. 所以在<strong>C++中const修饰的量可以用在数组</strong>的定义中。</div>
<div>&nbsp;</div>
<div>&nbsp; &nbsp; 而在C中,const是一个不能被改变的普通变量,既然是变量,就要占用存储空间,所以编译器不知道编译时的值.而且,数组定义时的下标必须为常量.</div>
<div>&nbsp;</div>
<div>&nbsp; &nbsp; 在C语言中: const int size; 这个语句是正确的，因为它被C编译器看作一个声明,指明在别的地方分配存储空间。但在C++中这样写是不正确的.</div>
<div>&nbsp;</div>
<div>&nbsp; &nbsp; C++中const默认是内部连接,如果想在C++中达到以上的效果,必须要用extern关键字。 C++中,const默认使用内部连接；而C中使用外部连接.</div>
<div>&nbsp;</div>
<div>&nbsp; &nbsp; <strong>内连接:</strong></div>
<div>&nbsp; &nbsp; 编译器只对正被编译的文件创建存储空间,别的文件可以使用相同的表示符或全局变量.C/C++中内连接使用static关键字指定.</div>
<div>&nbsp;</div>
<div>&nbsp; &nbsp; <strong>外连接:</strong></div>
<div>&nbsp; &nbsp; 所有被编译过的文件创建一片单独存储空间.一旦空间被创建,连接器必须解决对这片存储空间的引用.全局变量和函数使用外部连接.通过extern关键字声明,可以从其他文件访问相应的变量和函数. C++中,是否为const分配空间要看具体情况. 如果加上关键字extern或者取const变量地址,则编译器就要为const分配存储空间.</div>
<div>&nbsp;</div>
<div>&nbsp; &nbsp;<strong> C++中定义常量的时候不再采用define,因为define只做简单的宏替换，并不提供类型检查.</strong></div>
<div>&nbsp;</div>
<h2>2.const指针和指向const的指针</h2>
<div>&nbsp; &nbsp; 在C语言中const指针表示该指针是一个常量，一旦进行初始化完成之后就无法改变它指向的位置。指向const的指针说明使用这个指针无法改变其指向的地址处的值，特别强调的一点是使用这个指针不能够改变。言外之意就是说，可以通过其他的方式改变。</div>
<div>&nbsp;</div>
<div>比如：char ch='c';</div>
<div>&nbsp;</div>
<div>const char *ptr=&amp;ch;</div>
<div>&nbsp;</div>
<div>*ptr='a';//这样做是不允许的</div>
<div>&nbsp;</div>
<div>ch='a';//这样做完全可以，并且*ptr的值也是'a'</div>
<div>&nbsp;</div>
<div>下面是从网上摘抄的对const不错的总结</div>
<h2>3.const用法小结：</h2>
<div>const最常用的就是定义常量，除此之外，它还可以修饰函数的参数、返回值和函数的定义体。</div>
<h3>3.1. const修饰函数的参数</h3>
<div>如果参数作输出用，不论它是什么数据类型，也不论它采用&ldquo;指针传递&rdquo;还是&ldquo;引用传递&rdquo;，都不能加const 修饰，否则该参数将失去输出功能。</div>
<div>const 只能修饰输入参数：</div>
<div>如果输入参数采用&ldquo;指针传递&rdquo;，那么加const 修饰可以防止意外地改动该指针，起到保护作用。</div>
<div>将&ldquo;const &amp;&rdquo;修饰输入参数的用法总结如下：</div>
<div><strong>(1)对于非内部数据类型的输入参数，应该将&ldquo;值传递&rdquo;的方式改为&ldquo;const 引用传递&rdquo;，目的是提高效率。例如将void Func(A a) 改为void Func(const A &amp;a)。</strong></div>
<div><strong>(2)对于内部数据类型的输入参数，不要将&ldquo;值传递&rdquo;的方式改为&ldquo;const 引用传递&rdquo;。否则既达不到提高效率的目的，又降低了函数的可理解性。例如void Func(int x) 不应该改为void Func(const int &amp;x)。</strong></div>
<h3>3.2. const 修饰函数的返回值</h3>
<div>如果给以&ldquo;指针传递&rdquo;方式的函数返回值加const 修饰，那么函数返回值（即指针）的内容不能被修改，该返回值只能被赋给加const 修饰的同类型指针。例如函数</div>
<div>const char * GetString(void);</div>
<div>如下语句将出现编译错误：</div>
<div>char *str = GetString();</div>
<div>正确的用法是</div>
<div>const char *str = GetString();</div>
<div>&nbsp;</div>
<div>如果返回值不是内部数据类型，将函数A GetA(void) 改写为const A &amp; GetA(void)的确能提高效率。但此时千万千万要小心，一定要搞清楚函数究竟是想返回一个对象的&ldquo;拷贝&rdquo;还是仅返回&ldquo;别名&rdquo;就可以了，否则程序会出错。</div>
<div>函数返回值采用&ldquo;引用传递&rdquo;的场合并不多，这种方式一般只出现在类的赋值函数中，目的是为了实现链式表达。</div>
<div>例如：</div>
<div>
<div>
<pre class="prettyprint linenums">class A<br />
{<br />
 A &amp; operate =(const A &amp;other);// 赋值函数<br />
};

A a, b, c;// a, b, c 为A 的对象<br />
a = b = c;// 正常的链式赋值<br />
a = b)= c;// 不正常的链式赋值，但合法</pre>
</div>
<p>如果将赋值函数的返回值加const 修饰，那么该返回值的内容不允许被改动。上例中，语句 a = b = c 仍然正确，但是语句 (a = b) = c 则是非法的。</p>
</div>
<h3>3.3. const修饰成员函数</h3>
<div>关于Const函数的几点规则：</div>
<div>a. const对象只能访问const成员函数,而非const对象可以访问任意的成员函数,包括const成员函数.</div>
<div>b. const对象的成员是不可修改的,然而const对象通过指针维护的对象却是可以修改的.</div>
<div>c. const成员函数不可以修改对象的数据,不管对象是否具有const性质.它在编译时,以是否修改成员数据为依据,进行检查.</div>
<div>e. 然而加上mutable修饰符的数据成员,对于任何情况下通过任何手段都可修改,自然此时的const成员函数是可以修改它的</div>
<h3>3.4. 函数前和函数后添加const修饰符的区别</h3>
<div>
<div>1、非静态成员函数后面加const（加到非成员函数或静态成员后面会产生编译错误）</div>
<div>2、表示成员函数隐含传入的this指针为const指针，决定了在该成员函数中，&nbsp;任意修改它所在的类的成员的操作都是不允许的（因为隐含了对this指针的const引用）；</div>
<div>3、唯一的例外是对于mutable修饰的成员。</div>
<div>&nbsp; &nbsp; 加了const的成员函数可以被非const对象和const对象调用</div>
<div>&nbsp; &nbsp; 但不加const的成员函数只能被非const对象调用</div>
<div>&nbsp;</div>
</div>
<div><a href="http://www.wiz.cn/i/fbe62488" rel="external nofollow noreferrer">来自为知笔记(Wiz)</a></div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8krl13q.html">Using Stored Programs with MySQLdb</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qyn7zm9.html">【转】CentOS6&period;3安装Broadcom无线网卡驱动</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq13px08.html">Android 使用Fragment界面向下跳转并一级级返回</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pj26179.html">faplayer编译配置经验</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mdznj8.html">zf-关于注册码过期</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1gry2q.html">vue的增删改查</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7z2nxg9.html">Java异常的性能分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7z30d19.html">CPU频率</a>
		</li>
						<li><a href="https://www.batexi.com/a/8me0wlpq.html">ztree 为节点添加点击触发事件</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j17g209.html">day3&lowbar;文件操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zkovlx8.html">对一个前端使用AngularJS后端使用ASP&period;NET Web API项目的理解&lpar;3&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdjjx0zq.html">Javascript动态操作CSS总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvedm2j9.html">Vim多行编辑</a>
		</li>
						<li><a href="https://www.batexi.com/a/953dwk08.html">ASP&period;NET MVC学习之模型验证详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o43m6pq.html">django下载excel，使用django-excel插件</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql1xvpk9.html">Python之paramiko模块和SQL连接API</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kol0ejq.html">Android实现圆形的图片边角</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zkmvmn8.html">Vue学习记录-画页面</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwoo30y9.html">【BZOJ】1419 Red is good</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlovd2eq.html">&lowbar;&lowbar;&lowbar;pInvalidArgHandler already defined in LIBCMTD&period;lib&lpar;invarg&period;obj&rpar;</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qvvyg3zq.html">Python自动化运维之2、运算符与数据类型</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gm7nxz9.html">Python文件处理之文件打开方式（一）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e1gpne9.html">文件夹Tab Ctrl</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z1wgex9.html">java之多线程的理解</a>
			</li>
						<li><a href="https://www.batexi.com/a/qydkdrdq.html">&lbrack;翻译&rsqb;localStorage性能的好坏</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7mrlgxq.html">HDFS文件读取详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvvlz3xq.html">Swing UI - 可收起与开展内容面板实现演示</a>
			</li>
						<li><a href="https://www.batexi.com/a/qn1oym28.html">EF中主表和附表一起提交的话，如果主附表的主键外键已经设定。</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gmw5109.html">Wamp集成环境配置多站点</a>
			</li>
						<li><a href="https://www.batexi.com/a/qde2zzx9.html">MVC VIEW 时间格式控制</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
